#!/bin/bash -eu

# 1. update to redis CR/operator
# 2. wait for redis to be ready
# 3. dump
# 4. update
# 5. wait for update done
# 6. /usr/local/bin/php occ config:app:set theming backgroundMime --value="backgroundColor"
# 7. /usr/local/bin/php occ polls:db:rebuild
# 8. fix theming for those needed - /usr/local/bin/php occ config:app:get theming_customcss customcss

# TODO kubfledge 

for nuage in `kubectl get ing -l app.kubernetes.io/name=nextcloud -A --no-headers -o custom-columns=":metadata.name" | sed s/-web//g`; do
  export NS=`echo $nuage | cut -d"-" -f2-`
  export SUBDOMAIN=`echo $nuage | cut -d"-" -f1`
  echo Deploying redis $SUBDOMAIN $NS ...
  export APP=${SUBDOMAIN}-${NS}
  cd $NS/$SUBDOMAIN

  kubectl apply -f - <<EOF
  apiVersion: core.libre.sh/v1alpha1
  kind: Redis
  metadata:
    name: $APP-redis
    namespace: ${NS}
  spec:
    disableAuth: true
  EOF

  kubectl -n ${NS} wait --for=condition=ready redis $APP-redis
  kubectl delete -n ${NS} deploy redis

  echo Update nextcloud $SUBDOMAIN $NS ...
  libre update --force 
done

for nuage in `kubectl get ing -l app.kubernetes.io/name=nextcloud -A --no-headers -o custom-columns=":metadata.name" | sed s/-web//g`; do
  export NS=`echo $nuage | cut -d"-" -f2-`
  export SUBDOMAIN=`echo $nuage | cut -d"-" -f1`
  echo Deploying redis $SUBDOMAIN $NS ...
  export APP=${SUBDOMAIN}-${NS}
  cd $NS/$SUBDOMAIN

  # TODO scaledown ?? 

  libre apply /root/domains/common/migrations/2023-06-22-update-nc-25-job.yaml
done

while read nuage; do
  export NS=`echo $NS | cut -d"/" -f1-`
  export NAME=`echo $forum | cut -d"/" -f2`

  # TODO WAIT FOR JOB ??

  kubectl -n $NS exec deploy/$NAME -c app -- '/usr/local/bin/php occ config:app:set theming_customcss customcss --value=""'
done <~/root/unteem/nuage_custom_css_to_clean
